//160917 fujigaya2

#include "DenshaMascon.h"
//#include <Wire.h>
#include <ST7032.h>
#include <string.h>
#include <EEPROM.h>

ST7032 lcd;
Mascon Joystick;

//EEP ROM
//address
#define EEP_LOCO_NO 0
#define EEP_CONTROL 1
#define EEP_ACC_RATE 2  //加速レート
#define EEP_DEC_RATE 3   //減速レート
#define EEP_COAST_RATE 4  //惰行レート
#define EEP_DISP_MAX 5

#define EEP_LOCO_NO_DEFAULT 3
#define EEP_CONTROL_DEFAULT 0
#define EEP_ACC_RATE_DEFAULT 30
#define EEP_DEC_RATE_DEFAULT 40
#define EEP_COAST_RATE_DEFAULT 5
#define EEP_DISP_MAX_DEFAULT 100

//S88

// reference : RB_S88
// Software by Ruud Boer, November 2014.
// https://rudysmodelrailway.wordpress.com/software/

int clk_counter=0;
const byte dataIn=5;  //data input from next Arduino in S88 chain
const byte dataOut=6; //data output pin=6


//Sensor control
#define IR_LED_PIN 7 // IR_LED(sensor LED) on/off pin
#define RUN_LED_PIN 8 // RUN_LED(status LED) on/off pin
#define SENSOR_INTERVAL 5 //sensor interval[ms]
#define CONT_PORT_NUM 16 //port_num to see from DCC Controller

uint16_t transfer_value;
uint16_t sensor_value; 
uint16_t out_value;
boolean out_flag = false;

//Task Schedule
unsigned long gPreviousL5 = 0; //   50ms interval
unsigned long gPreviousL8 = 0; // 100ms interval
unsigned long gPreviousL9 = 0; // s_state用

//joystick
int joy_gear_mode = GEAR_MODE_SPD;//EEP_CONTROL_DEFAULT
int joy_loco_no = EEP_LOCO_NO_DEFAULT;
int joy_accrate = EEP_ACC_RATE_DEFAULT;//50msecでどのくらい加速するか？２０４８が１００％の基準
int  joy_decrate = EEP_DEC_RATE_DEFAULT;
int  joy_coastrate = EEP_COAST_RATE_DEFAULT;
int joy_loco_dir = 0;
int joy_loco_speed = 0;
int joy_function_no = 0;
int joy_function_no_sub = 0;
int joy_disp_speed = 100;//最高速表示を何キロにするか？
int joy_function[28] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int joy_mode_select = 0;
int joy_start_long_push_count = 0;


int joy_loco_dir_prev = 0;
int joy_loco_speed_prev = 0;
int set_s88_switch = 4;

//0:速度・進行方向
//1:ファンクション１
//2:ファンクション２
//3:Acc Address
//4:Loc Address
//100:空
int SendReserveFlag = 100;

enum _s_state
{
  s_setup,//:初期表示 Verとかも表示するか？
  s_setup_wait,//:メイン画面までの待ち
  s_drive_speed,//:LocoNo,FunctionSelect,Dir,Speedを表示
  s_drive_wait,//s_mode_selectへ行くまでのStartボタン長押し確認
  s_drive_function,//:a,b,cボタンが押されたらfunctionが押されたことを表示（1秒後にもどる）
  s_drive_function_wait,//メイン画面までの待ち
  s_mode_select,//:Startボタン長押しで遷移する。ここからはセレクトボタンで選んでＡボタンでＯＫ,+、Cボタンが-、スタートボタン長押しでももとにもどれるようにする
  s_mode_wait,//:Startボタン長押しで遷移する。
  s_mode_save,
  s_mode_load,  
} s_state = s_setup;

char aText[16 + 1];

void setup()
{
  //S88
  //S88 Control
  pinMode(2, INPUT_PULLUP);
  attachInterrupt(0,clk,RISING); //pin 2 = clock interrupt
  pinMode(3, INPUT_PULLUP);
  attachInterrupt(1,PS,RISING);    //pin 3 = PS interrupt
  pinMode(dataIn,INPUT_PULLUP); // data in from next Arduino S88 in chain
  pinMode(dataOut, OUTPUT); // data out to commnad station or to previous Arduino in S88 chain
  digitalWrite(dataOut, LOW);   
  
  //Sensor Control
  pinMode(IR_LED_PIN, OUTPUT);
  //Status LED Control
  pinMode(RUN_LED_PIN, OUTPUT);
  
  //init sensor_value,transfer_value
  transfer_value = 0;
  sensor_value = 0;
  
  // put your setup code here, to run once:
  //PSX
  Joystick.setupPins(MASCON_dataPin, MASCON_cmndPin, MASCON_attPin, MASCON_clockPin, 10);
  Serial.begin(115200);
  Serial.println("Serial Begin.");


  //LCD
  // set up the LCD's number of columns and rows: 
  lcd.begin(8, 2);
  lcd.setContrast(12);            // コントラスト設定
  lcd.setCursor(0,0);//列、行
  lcd.print("Speed");

  //EEPROM Read
  //ROM関連
  if(ReadROM_int(EEP_LOCO_NO) == 0)
  {
    //ROM初期化が行われていない
    //ソースの初期値を入れる
    WriteROM_AllCurrent();
  }
  ReadROM_All();
}

void loop()
{
  // put your main code here, to run repeatedly:
  
  //joystick 
  if( (millis() - gPreviousL5) >= 50)
  {
/*
    if(SendReserveFlag != 100)
    {
      Serial.print(" set_s88_switch:");  
      Serial.print(set_s88_switch,BIN);  
      Serial.print(" sensor_value:");  
      Serial.println(sensor_value,BIN);  
    }
*/
    //Joystick
    //Read joystick Status 
    unsigned int aPsxData = Joystick.read();
    //検知用にバッファに入れておく
    Joystick.PutButtonBuffer(aPsxData);
    //Store status from aPsxData to gPower 
    Joystick.GetHandleStatus(aPsxData);
    //Read ButtonStatus and continueously push count    
    Joystick.GetButtonStatus(aPsxData);
    //Speed 
    Joystick.Interval(joy_gear_mode ,joy_accrate,joy_decrate ,joy_coastrate );

    DoJoystickEvent(aPsxData);

    //Reset task
    gPreviousL5 = millis();

    //メモ！
    //S88のPSでリセットする。押されたらラッチ。
    //    sensor_value |= aButton << 11;
  }
  
  //LCD関連
  if( (millis() - gPreviousL8) >= 100)
  {
    {

    }
    //Reset task
    gPreviousL8 = millis();
  }
}

//S88
void PS()
{
  //Set transfer value
  clk_counter=0;
  out_flag = true;
  out_value = sensor_value;
  //0リセットはボタン系だけ
  //sensor_value &= 0x07FF;
}

//S88
void clk()
{
  //transfer 
  if(out_flag == true)
  {
    digitalWrite(dataOut,(out_value >> clk_counter) & 0x1);
  }
  else
  {
    digitalWrite(dataOut,(transfer_value >> clk_counter) & 0x1);
  }
  //Delay makes reading output signal from next Arduino in chain more reliable.
  delayMicroseconds(16); 
  //Store dataIn value
  //transfer_value[clk_counter] = digitalRead(dataIn);
  if(digitalRead(dataIn) == 1)
  {
     transfer_value |= 1 << clk_counter;
  }
  else
  {
     transfer_value &= ~(1 << clk_counter);
  }

  //  clk_counter =(clk_counter +1) % CONT_PORT_NUM;
  if(clk_counter < CONT_PORT_NUM - 1)
  {
    clk_counter ++;
  }
  else
  {
    clk_counter = 0;
    out_flag = false;
    SendReserveFlag = 100;//SendFlagリセット
  }
}

void DoJoystickEvent(unsigned int inData)
{
  int temp = 0;
  int disp_speed = 0;

  switch(s_state)
  {
    case s_setup:
      gPreviousL9 = millis();
      lcd.setCursor(0,0);//列、行
      lcd.print("S88 Mscn");
      lcd.setCursor(0,1);//列、行
      lcd.print("Ver 1.08");
      s_state = s_setup_wait;
      break;
    case s_setup_wait:
      if( (millis() - gPreviousL9) >= 1000)
      {
        s_state = s_drive_speed;
      }
      break;
    case s_drive_speed:
      //Speed 
      joy_loco_speed = Joystick.GetSpeedValue();
      //とりあえず　速度の送信
      //sensor_value &= 0xf800;
      //sensor_value |= Joystick.GetSpeedValue();
      setS88_dir_speed();

      //MainDisp
      lcd.setCursor(0,1);//列、行
      disp_speed = (int)((long)Joystick.GetSpeedValue() * (long)(joy_disp_speed+1) / (long)2048);
      if (joy_loco_dir == 0)
      {
        sprintf(aText, "F %s%3dK",Joystick.GetHandlePosition(),disp_speed);
      }
      else
      {
        //sprintf(aText, "REV %3dK",disp_speed);
        sprintf(aText, "R %s%3dK",Joystick.GetHandlePosition(),disp_speed);
      }
      lcd.print(aText);
      lcd.setCursor(0,0);//列、行
      sprintf(aText, "L%04dF%02d",joy_loco_no,joy_function_no);
      lcd.print(aText);
      //短押し。ボタンのOn.Offの遷移があったときに確認。
      if(Joystick.CheckButtonBuffer(inData) == 0)
      {
        if((Joystick.GetButtonStatus(inData) & JOYSTICK_SELECT) > 0)
        {
          joy_function_no+=3;
          //F0～F11
          if(joy_function_no >12)
             joy_function_no = 0;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_START) > 0)
        {
          //mode 遷移
          joy_start_long_push_count = 0;
          s_state = s_drive_wait;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_A) > 0)
        {
          //Function A
          joy_function_no_sub = 0;
          s_state = s_drive_function;
          //仮
          //sensor_value |= JOYSTICK_A << 11;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_B) > 0)
        {
          //Function B
          joy_function_no_sub = 1;
          s_state = s_drive_function;
          //仮
          //sensor_value |= JOYSTICK_B << 11;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_C) > 0)
        {
          //Function C
          joy_function_no_sub = 2;
          s_state = s_drive_function;
          //仮
          //sensor_value |= JOYSTICK_C << 11;
        }
      }
      break;
    case s_drive_function:
      //トグル　ファンクション送信
      joy_function[joy_function_no + joy_function_no_sub] = -joy_function[joy_function_no + joy_function_no_sub] + 1;
      setS88_function(joy_function_no + joy_function_no_sub);
      lcd.setCursor(0,0);//列、行
      sprintf(aText, "FUNC: %02d ",joy_function_no + joy_function_no_sub);
      lcd.print(aText);
      lcd.setCursor(0,1);//列、行
      if(joy_function[joy_function_no + joy_function_no_sub] == 1)
      {
        lcd.print("VAL:  ON");
      }
      else
      {
        lcd.print("VAL: OFF");
      }
      gPreviousL9 = millis();
      s_state = s_drive_function_wait;
      break;
    case s_drive_function_wait:
      if( (millis() - gPreviousL9) >= 500)
      {
        s_state = s_drive_speed;
      }
      break;
    case s_drive_wait:
      //長押し確認 確認できない場合は、Directionを変更して戻る
      if(joy_start_long_push_count == 10)      
      {
        joy_mode_select = 0;
        s_state = s_mode_select;
      }
      else if((Joystick.GetButtonStatus(inData) & JOYSTICK_START) ==0)
      {
        //長押し条件成立前にボタンが離れていたら方向転換
        joy_loco_dir = -joy_loco_dir + 1;
        setS88_dir_speed();
        lcd.setCursor(0,0);//列、行
        //sprintf(aText, "Dir:    ",joy_function_no + joy_function_no_sub);
        //lcd.print(aText);
        //lcd.setCursor(0,1);//列、行
        if(joy_loco_dir == 0)
        {
          lcd.print("FORWARD ");
        }
        else
        {
          lcd.print("REVERSE ");
        }
        gPreviousL9 = millis();
        
        //とりあえず、Startボタンが押されたことだけ送る。（方向は無視）
        //S88のPSでリセットする。押されたらラッチ。
        //sensor_value |= JOYSTICK_START << 11;
        
        s_state = s_drive_function_wait;
      }
      joy_start_long_push_count ++;
      break;
    case s_mode_select:
      lcd.setCursor(0,0);//列、行
      switch(joy_mode_select)
      {
        case 0:
          lcd.print("?Loco   ");
          lcd.setCursor(0,1);//列、行
          sprintf(aText, " %04d   ",joy_loco_no);
          lcd.print(aText);
          break;
        case 1:
          lcd.print("?Control");
          lcd.setCursor(0,1);//列、行
          if(joy_gear_mode == GEAR_MODE_ACC)
          {
            lcd.print("NORMAL  ");
          }
          else
          {
            lcd.print("SPEED   ");
          }
          break;
        case 2:
          lcd.print("?AccRate");
          lcd.setCursor(0,1);//列、行
          sprintf(aText, "  %03d   ",joy_accrate);
          lcd.print(aText);
          break;                       
        case 3:
          lcd.print("?DecRate");
          lcd.setCursor(0,1);//列、行
          sprintf(aText, "  %03d   ",joy_decrate);
          lcd.print(aText);
          break;                       
        case 4:
          lcd.print("?CstRate");
          lcd.setCursor(0,1);//列、行
          sprintf(aText, "  %03d   ",joy_coastrate);
          lcd.print(aText);
          break;                       
        case 5:
           //Max Display Speed 
          lcd.print("?DispSpd");
          lcd.setCursor(0,1);//列、行
          sprintf(aText, "  %03d   ",joy_disp_speed);
          lcd.print(aText);
          break;                       
        case 6:
          lcd.print("SAVE    ");
          lcd.setCursor(0,1);//列、行
          lcd.print("A:OK");
          break;                       
        case 7:
          lcd.print("LOAD    ");
          lcd.setCursor(0,1);//列、行
          lcd.print("A:OK");
          break;                       
        default:
          lcd.print("????????");
          break;                       
      }
      //process
      //短押し。ボタンのOn.Offの遷移があったときに確認。
      if(Joystick.CheckButtonBuffer(inData) == 0)
      {
        if((Joystick.GetButtonStatus(inData) & JOYSTICK_SELECT) > 0)
        {
        joy_mode_select+=1;
        if(joy_mode_select > 7)
           joy_mode_select = 0;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_START) > 0)
        {
          //mode 遷移
          joy_start_long_push_count = 0;
          s_state = s_mode_wait;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_A) > 0)
        {
            temp++;
            joy_start_long_push_count = 0;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_B) > 0)
        {
            //
            joy_start_long_push_count = 0;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_C) > 0)
        {
            temp--;
            joy_start_long_push_count = 0;
        }
      }
      else
      {
        //連続押し
        if((Joystick.GetButtonStatus(inData) & JOYSTICK_A) > 0)
        {
          joy_start_long_push_count++;
          if(joy_start_long_push_count > 10)
            temp += joy_start_long_push_count / 10;
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_B) > 0)
        {
            //
        }
        else if((Joystick.GetButtonStatus(inData) & JOYSTICK_C) > 0)
        {
          joy_start_long_push_count++;
          if(joy_start_long_push_count > 10)
            temp -= joy_start_long_push_count / 10;
        }
      }
      // 値の代入
      switch(joy_mode_select)
      {
        case 0:
          //lcd.print("?Loco   ");
          joy_loco_no += temp;
          if(joy_loco_no < 0)
            joy_loco_no = 9999;
          else if (joy_loco_no > 9999)
            joy_loco_no = 0;
          break;
        case 1:
          //lcd.print("?Control");
          //手抜き
          if(temp != 0)
            joy_gear_mode = -joy_gear_mode + 1;
          break;
        case 2:
          //lcd.print("?AccRate");
          joy_accrate += temp;
          if(joy_accrate < 0)
            joy_accrate = 0;
          else if (joy_accrate > 1024)
            joy_accrate = 1024;
          break;                       
        case 3:
          //lcd.print("?DecRate");
          joy_decrate += temp;
          if(joy_decrate < 0)
            joy_accrate = 0;
          else if (joy_decrate > 1024)
            joy_decrate = 1024;
          break;                       
        case 4:
          //lcd.print("?CstRate");
          joy_coastrate += temp;
          if(joy_coastrate < 0)
            joy_coastrate = 0;
          else if (joy_coastrate > 1024)
            joy_coastrate = 1024;
          break;                       
        case 5:
           //Max Display Speed 
          //lcd.print("?DispSpd");
          joy_disp_speed += temp;
          if(joy_disp_speed < 0)
            joy_disp_speed = 0;
          else if (joy_disp_speed > 1024)
            joy_disp_speed = 1024;
          break;                       
        case 6:
          //lcd.print("SAVE    ");
          if(temp == 1)
          {
            s_state = s_mode_save;
          }
          break;                       
        case 7:
          //lcd.print("LOAD    ");
          if(temp == 1)
          {
            s_state = s_mode_load;
          }
          break;                       
        default:
          //lcd.print("????????");
          break;
      }
      break;
    case s_mode_wait:
       //長押し確認 確認できない場合は、s_mode_waitに戻る
      if(joy_start_long_push_count == 10)      
      {
        joy_mode_select = 0;
        s_state = s_drive_speed;
      }
      else if((Joystick.GetButtonStatus(inData) & JOYSTICK_START) ==0)      
      {
        //s_mode_selectに行く
        s_state = s_mode_select;
      }
      joy_start_long_push_count ++;
      break;
    case s_mode_save:
      WriteROM_AllCurrent();
      lcd.print("SAVE    ");
      lcd.setCursor(0,1);//列、行
      lcd.print("Done.   ");
      s_state = s_mode_select;
      break;
    case s_mode_load:
      ReadROM_All();
      lcd.print("LOAD    ");
      lcd.setCursor(0,1);//列、行
      lcd.print("Done.   ");
      s_state = s_mode_select;
      break;
    default:
      Serial.println("Error?");
      break;
  }
}

/*
int joy_loco_no = 3;
int joy_loco_dir = 0;
int joy_function_no = 0;
int joy_function_no_sub = 0;
int joy_accrate = 5;//50msecでどのくらい加速するか？２０４８が１００％の基準
int joy_disp_speed = 100;//最高速表示を何キロにするか？
int joy_function[28] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
*/

uint16_t parity_calc(uint16_t inData)
{
  uint16_t aParity = 0;
   /* パリティ計算 */
  for( int i = 0; i < 15; i++)
  {
    aParity = aParity ^ ((inData >> i) & 1);
  }
  return aParity;
}

void S88_type0_set_function()
{
  //Type0 全書き
  Serial.println("S88_type0_set_function"); 
  SendReserveFlag = 0;
  uint16_t speed63 =(((uint16_t) joy_loco_speed) >> 5) & 0x003F;
  sensor_value = 0x0000;
  sensor_value |= speed63;
  sensor_value |= (uint16_t)joy_loco_dir << 6;
  for(int i = 0;i < 5;i++)
  {
    //sensor_value |= ((uint16_t)joy_function[i]) << (7 + i);
    sensor_value |= ((uint16_t)joy_function[i] & 0b1) << (7 + i);
  }
  sensor_value |= parity_calc(sensor_value) << 15;  
}

void S88_type1_set_function()
{
  //Type1 fn5-16全書き
  Serial.println("S88_type1_set_function"); 
  SendReserveFlag = 1;
  sensor_value = 0x0000;
  sensor_value |= 0x1000;
  for(int i = 0;i < 12;i++)
  {
    //sensor_value |= ((uint16_t)joy_function[i+5]) << i;
    sensor_value |= (joy_function[i+5] & 0b1) << i;
  }
  sensor_value |= parity_calc(sensor_value) << 15;  
}

void S88_type2_set_function()
{
  //Type2 fn17-28 全書き
  Serial.println("S88_type2_set_function"); 
  SendReserveFlag = 2;
  sensor_value = 0x0000;
  sensor_value |= 0x2000;
  for(int i = 0;i < 12;i++)
  {
    //sensor_value |= ((uint16_t)joy_function[i+17]) << i;
    sensor_value |= ((uint16_t)joy_function[i+17] & 0b1) << i;
  }
  sensor_value |= parity_calc(sensor_value) << 15;  
}

void S88_type4_set_function()
{
  //Type4 LocoNo 全書き
  Serial.println("S88_type4_set_function"); 
  SendReserveFlag = 4;
  sensor_value = 0x0000;
  sensor_value |= 0x4000;
  sensor_value |= (uint16_t)joy_loco_no;
  sensor_value |= parity_calc(sensor_value) << 15;  
}

void setS88_dir_speed()
{
  //direction,speed
  //定期送信時はLocAddress,その他を順番に送信する。
  if(SendReserveFlag == 100)
  {
    if((joy_loco_speed != joy_loco_speed_prev) || (joy_loco_dir != joy_loco_dir_prev))
    {
      //スピードが変更なら
      //direction,speed
      S88_type0_set_function();
      Serial.println("dir_speed"); 
    }
    else
    {
      //定期送信
      switch(set_s88_switch)
      {
        case 0:
          S88_type0_set_function();
          break;
        case 1:
          S88_type1_set_function();
          break;
        case 2:
          S88_type2_set_function();
          break;
        case 4:
        default:
          S88_type4_set_function();
          break;
      }
      //トグル
      if(set_s88_switch == 4)
      {
        set_s88_switch = 0;
      }
      else
      {
        set_s88_switch ++;
      }
    }
  }
  joy_loco_speed_prev = joy_loco_speed;
  joy_loco_dir_prev = joy_loco_dir;
  
//  Serial.print("setS88_dir_speed: ");
//  Serial.println(sensor_value,BIN);
}

void setS88_function(int change_functin_number)
{
  if(change_functin_number <= 4)
  {
    S88_type0_set_function();
  }
  else if(change_functin_number <= 16)
  {
    S88_type1_set_function();
  }
  else //17 - 28
  {
    S88_type2_set_function();
  }

//  Serial.print("setS88_Function: ");
//  Serial.println(sensor_value,BIN);
}

//EEPROM関連
void WriteROM_int(int address,int value)
{
  //int値書き込み
  int value_h = (value >> 8) & 0xff;
  int value_l = (value) & 0xff;
  EEPROM.write(address * 2,value_h);
  EEPROM.write(address * 2 + 1,value_l);
  Serial.println("write rom");
  Serial.println(value_h);
  Serial.println(value_l);
  lcd.setCursor(0,0);//列、行
  lcd.print("RomWrite");
  lcd.setCursor(0,1);//列、行
  sprintf(aText,"%4d%4d",address,value);
  lcd.print(aText);
}

int ReadROM_int(int address)
{
  //int値読み込み
  int value_h = EEPROM.read(address * 2);
  int value_l = EEPROM.read(address * 2 + 1);
  Serial.println("read rom");
  Serial.println(value_h);
  Serial.println(value_l);
  Serial.println((value_h << 8) + value_l);
  lcd.setCursor(0,0);//列、行
  lcd.print("RomRead");
  lcd.setCursor(0,1);//列、行
  sprintf(aText,"%4d%4d",address,(value_h << 8) + value_l);
  lcd.print(aText);
  return ((value_h << 8) + value_l);
}

void ReadROM_All()
{
  joy_loco_no = ReadROM_int(EEP_LOCO_NO);
  joy_gear_mode = ReadROM_int(EEP_CONTROL);
  joy_accrate = ReadROM_int(EEP_ACC_RATE);
  joy_decrate = ReadROM_int(EEP_DEC_RATE);
  joy_coastrate = ReadROM_int(EEP_COAST_RATE);
  joy_disp_speed = ReadROM_int(EEP_DISP_MAX);
}

void WriteROM_AllCurrent()
{
  // write current value all.
  WriteROM_int(EEP_LOCO_NO,joy_loco_no);
  WriteROM_int(EEP_CONTROL,joy_gear_mode);
  WriteROM_int(EEP_ACC_RATE,joy_accrate);
  WriteROM_int(EEP_DEC_RATE,joy_decrate);
  WriteROM_int(EEP_COAST_RATE,joy_coastrate);
  WriteROM_int(EEP_DISP_MAX,joy_disp_speed);
}
